Index: /palm/trunk/SOURCE/salsa_util_mod.f90
===================================================================
--- /palm/trunk/SOURCE/salsa_util_mod.f90	(revision 3467)
+++ /palm/trunk/SOURCE/salsa_util_mod.f90	(revision 3467)
@@ -0,0 +1,194 @@
+!> @file salsa_util_mod.f90
+!--------------------------------------------------------------------------------!
+! This file is part of PALM-4U.
+!
+! PALM-4U is free software: you can redistribute it and/or modify it under the 
+! terms of the GNU General Public License as published by the Free Software 
+! Foundation, either version 3 of the License, or (at your option) any later 
+! version.
+!
+! PALM-4U is distributed in the hope that it will be useful, but WITHOUT ANY
+! WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR
+! A PARTICULAR PURPOSE.  See the GNU General Public License for more details.
+!
+! You should have received a copy of the GNU General Public License along with
+! PALM. If not, see <http://www.gnu.org/licenses/>.
+!
+! Copyright 1997-2018 Leibniz Universitaet Hannover
+!--------------------------------------------------------------------------------!
+!
+! Current revisions:
+! -----------------
+! 
+! 
+! Former revisions:
+! -----------------
+! $Id$
+! Initial revision
+! 
+! 
+!
+! Authors:
+! --------
+! @author monakurppa
+!
+!
+! Description:
+! ------------
+!> Utility functions used in salsa_mod.
+!------------------------------------------------------------------------------!
+ MODULE salsa_util_mod
+ 
+    USE kinds
+    
+    USE pegrid
+    
+    IMPLICIT NONE
+    
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  sums_salsa_ws_l !< subdomain sum 
+                                        !< of vertical passive salsa flux w's' 
+                                        !< (5th-order advection scheme only)
+
+!-- Component index
+    TYPE component_index
+       INTEGER(iwp) ::  ncomp !< Number of components
+       INTEGER(iwp), ALLOCATABLE ::  ind(:) !< Component index
+       CHARACTER(len=3), ALLOCATABLE ::  comp(:) !< Component name
+    END TYPE component_index 
+    
+    SAVE
+    
+    INTERFACE component_index_constructor
+       MODULE PROCEDURE component_index_constructor
+    END INTERFACE component_index_constructor
+    
+    INTERFACE get_index
+       MODULE PROCEDURE get_index
+    END INTERFACE get_index
+    
+    INTERFACE get_n_comp
+       MODULE PROCEDURE get_n_comp
+    END INTERFACE get_n_comp
+    
+    INTERFACE is_used
+       MODULE PROCEDURE is_used
+    END INTERFACE is_used
+    
+    PRIVATE
+    PUBLIC component_index, component_index_constructor, get_index, get_n_comp,&
+           is_used, sums_salsa_ws_l
+    
+ CONTAINS
+    
+!------------------------------------------------------------------------------!    
+! Description:
+! ------------
+!> Creates index tables for different (aerosol) components 
+!------------------------------------------------------------------------------!
+    SUBROUTINE component_index_constructor( SELF, ncomp, nlist, listcomp )
+
+       IMPLICIT NONE
+       
+       TYPE(component_index), INTENT(inout) ::  SELF !< Object containing the indices 
+                                                     !< of different aerosol components
+       INTEGER(iwp), INTENT(inout) ::  ncomp !< Number of components
+       INTEGER(iwp), INTENT(in) ::     nlist !< Maximum number of components
+       CHARACTER(len=3), INTENT(in) ::  listcomp(nlist) !< List cof component
+                                                        !< names
+       INTEGER(iwp) ::  i, jj
+       
+       ncomp = 0
+       
+       DO  WHILE ( listcomp(ncomp+1) /= '  ' .AND. ncomp < nlist )
+          ncomp = ncomp + 1
+       ENDDO
+       
+       SELF%ncomp = ncomp 
+       ALLOCATE( SELF%ind(ncomp), SELF%comp(ncomp) )
+       
+       DO i = 1, ncomp
+          SELF%ind(i) = i
+       ENDDO
+       
+       jj = 1
+       DO i = 1, nlist
+          IF ( listcomp(i) == '') CYCLE
+          SELF%comp(jj) = listcomp(i)
+          jj = jj+1
+       ENDDO
+       
+    END SUBROUTINE component_index_constructor
+
+!------------------------------------------------------------------------------!
+! Description:
+! ------------
+!> Gives the index of a component in the component list
+!------------------------------------------------------------------------------!
+    INTEGER FUNCTION get_index( SELF, incomp )
+
+       IMPLICIT NONE
+       
+       TYPE(component_index), INTENT(in) ::  SELF !< Object containing the 
+                                                  !< indices of different 
+                                                  !< aerosol components
+       CHARACTER(len=*), INTENT(in) ::  incomp !< Component name
+       INTEGER(iwp) ::  i
+       
+       IF ( ANY(SELF%comp == incomp) ) THEN
+          i = 1
+          DO WHILE ( (SELF%comp(i) /= incomp) )
+             i = i+1
+          ENDDO
+          get_index = i
+       ELSEIF ( incomp == 'H2O' ) THEN
+          get_index = SELF%ncomp + 1
+       ELSE
+          STOP 'get_index: FAILED, no such component -'
+       ENDIF
+       
+       RETURN
+       
+    END FUNCTION get_index
+
+!------------------------------------------------------------------------------!
+! Description:
+! ------------
+!> Get the number of (aerosol) components used
+!------------------------------------------------------------------------------!
+    INTEGER FUNCTION get_n_comp( SELF )
+
+       IMPLICIT NONE
+
+       TYPE(component_index), INTENT(in) ::  SELF !< Object containing the 
+                                                  !< indices of different 
+                                                  !< aerosol components
+       get_n_comp = SELF%ncomp
+       RETURN
+       
+    END FUNCTION
+
+!------------------------------------------------------------------------------!
+! Description:
+! ------------
+!> Tells if the (aerosol) component is being used in the simulation
+!------------------------------------------------------------------------------!
+    LOGICAL FUNCTION is_used( SELF, icomp )
+
+       IMPLICIT NONE
+       
+       TYPE(component_index), INTENT(in) ::  SELF !< Object containing the 
+                                                  !< indices of different 
+                                                  !< aerosol components
+       CHARACTER(len=*), INTENT(in) ::  icomp !< Component name
+       
+       IF ( ANY(SELF%comp == icomp) ) THEN
+          is_used = .TRUE.
+       ELSE
+          is_used = .FALSE.
+       ENDIF
+       
+       RETURN
+       
+    END FUNCTION
+
+ END MODULE salsa_util_mod
Index: /palm/trunk/SOURCE/sum_up_3d_data.f90
===================================================================
--- /palm/trunk/SOURCE/sum_up_3d_data.f90	(revision 3466)
+++ /palm/trunk/SOURCE/sum_up_3d_data.f90	(revision 3467)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! Implementation of a new aerosol module salsa.
+! 
+! 3448 2018-10-29 18:14:31Z kanani
 ! Adjustment of biometeorology calls
 ! 
@@ -275,4 +278,7 @@
     USE radiation_model_mod,                                                   &
         ONLY:  radiation, radiation_3d_data_averaging
+         
+    USE salsa_mod,                                                             &
+        ONLY:  salsa, salsa_3d_data_averaging          
 
     USE surface_mod,                                                           &
@@ -539,4 +545,10 @@
                    CALL radiation_3d_data_averaging( 'allocate', doav(ii) )
                 ENDIF
+                
+!
+!--             SALSA quantity
+                IF ( salsa )  THEN
+                   CALL salsa_3d_data_averaging( 'allocate', doav(ii) )
+                ENDIF                
 
                 CALL tcm_3d_data_averaging( 'allocate', doav(ii) )
@@ -1187,4 +1199,10 @@
                 CALL radiation_3d_data_averaging( 'sum', doav(ii) )
              ENDIF
+             
+!
+!--          SALSA quantity
+             IF ( salsa )  THEN
+                CALL salsa_3d_data_averaging( 'sum', doav(ii) )
+             ENDIF                 
 
              CALL tcm_3d_data_averaging( 'sum', doav(ii) )
Index: /palm/trunk/SOURCE/surface_mod.f90
===================================================================
--- /palm/trunk/SOURCE/surface_mod.f90	(revision 3466)
+++ /palm/trunk/SOURCE/surface_mod.f90	(revision 3467)
@@ -175,4 +175,8 @@
 ! 2547 2017-10-16 12:41:56Z schwenkel
 ! extended by cloud_droplets option
+!
+! 2526 2017-10-10 11:29:14Z monakurppa
+! Implementation of a new aerosol module salsa: new surface fluxes for aerosols 
+! and gases.
 ! 
 ! 2508 2017-10-02 08:57:09Z suehring
@@ -322,4 +326,8 @@
        REAL(wp), DIMENSION(:), ALLOCATABLE ::  nrsws     !< surface flux nr
        REAL(wp), DIMENSION(:), ALLOCATABLE ::  sasws     !< surface flux salinity
+!--    Added for SALSA:
+       REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  answs   !< surface flux aerosol number: dim 1: flux, dim 2: bin
+       REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  amsws   !< surface flux aerosol mass:   dim 1: flux, dim 2: bin
+       REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  gtsws   !< surface flux gesous tracers: dim 1: flux, dim 2: gas
        
        REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  cssws   !< surface flux chemical species
@@ -522,4 +530,5 @@
        REAL(wp), DIMENSION(:), ALLOCATABLE ::  qsws_liq_eb_av       !< average of qsws_liq_eb
        REAL(wp), DIMENSION(:), ALLOCATABLE ::  t_surf_wall_av        !< average of wall surface temperature (K)
+       REAL(wp), DIMENSION(:), ALLOCATABLE ::  t_surf_av        !< average of wall surface temperature (K)
        REAL(wp), DIMENSION(:), ALLOCATABLE ::  t_surf_window_av !< average of window surface temperature (K)
        REAL(wp), DIMENSION(:), ALLOCATABLE ::  t_surf_green_av  !< average of green wall surface temperature (K)
Index: /palm/trunk/SOURCE/swap_timelevel.f90
===================================================================
--- /palm/trunk/SOURCE/swap_timelevel.f90	(revision 3466)
+++ /palm/trunk/SOURCE/swap_timelevel.f90	(revision 3467)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! Implementation of a new aerosol module salsa.
+! 
+! 3303 2018-10-03 12:04:15Z raasch
 ! bugfix for swapping in case of ocean mode
 ! 
@@ -158,5 +161,6 @@
     USE control_parameters,                                                    &
         ONLY:  air_chemistry, humidity, land_surface, neutral, ocean_mode,     &
-               passive_scalar, timestep_count, urban_surface
+               passive_scalar, simulated_time, timestep_count, urban_surface,  &
+               time_since_reference_point
 
     USE gust_mod,                                                              &
@@ -176,4 +180,7 @@
     USE pmc_interface,                                                         &
         ONLY: nested_run, pmci_set_swaplevel
+         
+    USE salsa_mod,                                                             &
+        ONLY:  salsa, salsa_swap_timelevel, skip_time_do_salsa             
 
     USE turbulence_closure_mod,                                                &
@@ -285,4 +292,8 @@
        CALL ocean_swap_timelevel( MOD( timestep_count, 2 ) )
     ENDIF
+   
+    IF ( salsa  .AND.  simulated_time >= time_since_reference_point )  THEN
+       CALL salsa_swap_timelevel(  MOD( timestep_count, 2 ) )
+    ENDIF  
 
     CALL tcm_swap_timelevel( MOD( timestep_count, 2) )
Index: /palm/trunk/SOURCE/time_integration.f90
===================================================================
--- /palm/trunk/SOURCE/time_integration.f90	(revision 3466)
+++ /palm/trunk/SOURCE/time_integration.f90	(revision 3467)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! Implementation of a new aerosol module salsa.
+! 
+! 3448 2018-10-29 18:14:31Z kanani
 ! Add biometeorology
 ! 
@@ -549,4 +552,9 @@
                stg_adjust, stg_main, time_stg_adjust, time_stg_call,           &
                use_syn_turb_gen
+         
+    USE salsa_mod,                                                             &
+        ONLY: aerosol_number, aerosol_mass, nbins, ncc_tot, ngast, salsa,      &
+              salsa_boundary_conds, salsa_gas, salsa_gases_from_chem,          &
+              skip_time_do_salsa           
 
     USE user_actions_mod,                                                      &
@@ -571,6 +579,9 @@
 
     CHARACTER (LEN=9) ::  time_to_string   !<
-
-    INTEGER(iwp)      ::  lsp       !<
+    
+    INTEGER(iwp)      ::  b !< index for aerosol size bins    
+    INTEGER(iwp)      ::  c !< index for chemical compounds in aerosol size bins
+    INTEGER(iwp)      ::  g !< index for gaseous compounds 
+    INTEGER(iwp)      ::  lsp
     INTEGER(iwp)      ::  lsp_usr   !<
     INTEGER(iwp)      ::  n         !< loop counter for chemistry species
@@ -694,5 +705,5 @@
           CALL cpu_log( log_point(55), 'wind_turbine', 'stop' )
 
-       ENDIF       
+       ENDIF   
        
 !
@@ -852,4 +863,34 @@
           ENDIF
 
+          IF ( salsa  .AND.  time_since_reference_point >= skip_time_do_salsa )&
+          THEN
+             CALL cpu_log( log_point_s(91), 'salsa exch-horiz ', 'start' )
+             DO  b = 1, nbins
+                CALL exchange_horiz( aerosol_number(b)%conc_p, nbgp )
+                CALL cpu_log( log_point_s(93), 'salsa decycle', 'start' )
+                CALL salsa_boundary_conds( aerosol_number(b)%conc_p,           &
+                                           aerosol_number(b)%init )
+                CALL cpu_log( log_point_s(93), 'salsa decycle', 'stop' )
+                DO  c = 1, ncc_tot
+                   CALL exchange_horiz( aerosol_mass((c-1)*nbins+b)%conc_p,    &
+                                        nbgp )
+                   CALL cpu_log( log_point_s(93), 'salsa decycle', 'start' )
+                   CALL salsa_boundary_conds( aerosol_mass((c-1)*nbins+b)%conc_p,&
+                                              aerosol_mass((c-1)*nbins+b)%init )
+                   CALL cpu_log( log_point_s(93), 'salsa decycle', 'stop' )
+                ENDDO
+             ENDDO
+             IF ( .NOT. salsa_gases_from_chem )  THEN
+                DO  g = 1, ngast
+                   CALL exchange_horiz( salsa_gas(g)%conc_p, nbgp ) 
+                   CALL cpu_log( log_point_s(93), 'salsa decycle', 'start' )
+                   CALL salsa_boundary_conds( salsa_gas(g)%conc_p,             &
+                                              salsa_gas(g)%init )
+                   CALL cpu_log( log_point_s(93), 'salsa decycle', 'stop' )
+             ENDDO
+             ENDIF
+             CALL cpu_log( log_point_s(91), 'salsa exch-horiz ', 'stop' )
+          ENDIF         
+
           CALL cpu_log( log_point(26), 'exchange-horiz-progn', 'stop' )
 
@@ -906,5 +947,6 @@
                 ENDIF
 
-                IF ( passive_scalar )  CALL exchange_horiz( s, nbgp )
+                IF ( passive_scalar )  CALL exchange_horiz( s, nbgp )  
+               
                 IF ( .NOT. constant_diffusion )  CALL exchange_horiz( e, nbgp )
 
@@ -926,5 +968,4 @@
 !--          Correct the w top-BC in nest domains to ensure mass conservation.
 !--          This action must never be done for the root domain. Vertical 
-!--          nesting implies mass conservation.
 !--          Commented out April 18, 2018 as seemingly unnecessary. 
 !--          Will later be completely removed.
@@ -1248,5 +1289,5 @@
           time_dopr       = time_dopr        + dt_3d
        ENDIF
-       time_dopr_listing          = time_dopr_listing        + dt_3d
+       time_dopr_listing  = time_dopr_listing + dt_3d
        time_run_control   = time_run_control + dt_3d
 !
Index: /palm/trunk/SOURCE/write_restart_data_mod.f90
===================================================================
--- /palm/trunk/SOURCE/write_restart_data_mod.f90	(revision 3466)
+++ /palm/trunk/SOURCE/write_restart_data_mod.f90	(revision 3467)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! Implementation of a new aerosol module salsa.
+! 
+! 3355 2018-10-16 14:03:34Z knoop
 ! changes concerning modularization of ocean option
 ! 
@@ -940,4 +943,7 @@
        USE random_generator_parallel,                                          &
            ONLY:  id_random_array, seq_random_array
+              
+       USE salsa_mod,                                                          &
+           ONLY:  salsa, salsa_wrd_local          
 
        USE surface_mod,                                                        &
@@ -1269,4 +1275,5 @@
        CALL surface_wrd_local
        IF ( radiation )            CALL radiation_wrd_local
+       IF ( salsa )                CALL salsa_wrd_local
        IF ( urban_surface )        CALL usm_wrd_local
 
